scala.tools.nsc.backend.jvm

# BTypes

###
Related Docs: object BTypes | package jvm

#### abstract class BTypes extends AnyRef

The BTypes component defines The BType class hierarchy. A BType stores all type information that is required after building the ASM nodes. This includes optimizations, generation of InnerClass attributes and generation of stack map frames.

The representation is immutable and independent of the compiler data structures, hence it can be queried by concurrent threads.

Source
  BTypes.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
BTypesFromSymbols
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BTypes
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new BTypes()

### Type Members

1. #### final case class ArrayBType (componentType: BType) extends RefBType with Product with Serializable

2. #### sealed trait BType extends AnyRef

   A BType is either a primitive type, a ClassBType, an ArrayBType of one of these, or a MethodType referring to BTypes.

3. #### final case class ClassBType (internalName: InternalName) extends RefBType with Product with Serializable

   A ClassBType represents a class or interface type.

   A ClassBType represents a class or interface type. The necessary information to build a ClassBType is extracted from compiler symbols and types, see BTypesFromSymbols.

   The `info` field contains either the class information on an error message why the info could not be computed. There are two reasons for an erroneous info:

   1. The ClassBType was built from a class symbol that stems from a java source file, and the symbol's type could not be completed successfully (SI-9111) 2. The ClassBType should be built from a classfile, but the class could not be found on the compilation classpath.

   Note that all ClassBTypes required in a non-optimzied run are built during code generation from the class symbols referenced by the ASTs, so they have a valid info. Therefore the backend often invokes `info.get` (which asserts the info to exist) when reading data from the ClassBType.

   The inliner on the other hand uses ClassBTypes that are built from classfiles, which may have a missing info. In order not to crash the compiler unnecessarily, the inliner does not force infos using `get`, but it reports inliner warnings for missing infos that prevent inlining.

4. #### final case class ClassInfo (superClass: Option[ClassBType], interfaces: List[ClassBType], flags: Int, nestedClasses: List[ClassBType], nestedInfo: Option[NestedInfo], inlineInfo: InlineInfo) extends Product with Serializable

   The type info for a class.

   The type info for a class. Used for symboltable-independent subtype checks in the backend.

   superClass

     The super class, not defined for class java/lang/Object.

   interfaces

     All transitively implemented interfaces, except for those inherited through the superclass.

   flags

     The java flags, obtained through `javaFlags`. Used also to derive the flags for InnerClass entries.

   nestedClasses

     Classes nested in this class. Those need to be added to the InnerClass table, see the InnerClass spec summary above.

   nestedInfo

     If this describes a nested class, information for the InnerClass table.

   inlineInfo

     Information about this class for the inliner.

5. #### final case class InnerClassEntry (name: String, outerName: String, innerName: String, flags: Int) extends Product with Serializable

   This class holds the data for an entry in the InnerClass table.

   This class holds the data for an entry in the InnerClass table. See the InnerClass summary above in this file.

   There's some overlap with the class NestedInfo, but it's not exactly the same and cleaner to keep separate.

   name

     The internal name of the class.

   outerName

     The internal name of the outer class, may be null.

   innerName

     The simple name of the inner class, may be null.

   flags

     The flags for this class in the InnerClass entry.

6. #### final case class MethodBType (argumentTypes: List[BType], returnType: BType) extends BType with Product with Serializable

7. #### final case class MethodNameAndType (name: String, methodType: MethodBType) extends Product with Serializable

   Just a named pair, used in CoreBTypes.asmBoxTo/asmUnboxTo.

8. #### final case class NestedInfo (enclosingClass: ClassBType, outerName: Option[String], innerName: Option[String], isStaticNestedClass: Boolean) extends Product with Serializable

   Information required to add a class to an InnerClass table.

   Information required to add a class to an InnerClass table. The spec summary above explains what information is required for the InnerClass entry.

   enclosingClass

     The enclosing class, if it is also nested. When adding a class to the InnerClass table, enclosing nested classes are also added.

   outerName

     The outerName field in the InnerClass entry, may be None.

   innerName

     The innerName field, may be None.

   isStaticNestedClass

     True if this is a static nested class (not inner class) (*) (*) Note that the STATIC flag in ClassInfo.flags, obtained through javaFlags(classSym), is not correct for the InnerClass entry, see javaFlags. The static flag in the InnerClass describes a source-level property: if the class is in a static context (does not have an outer pointer). This is checked when building the NestedInfo.

9. #### sealed trait PrimitiveBType extends BType

10. #### sealed trait RefBType extends BType

### Abstract Value Members

1. #### abstract val backendReporting: BackendReporting

2. #### abstract val byteCodeRepository: ByteCodeRepository

   Tools for parsing classfiles, used by the inliner.

3. #### abstract val callGraph: CallGraph[BTypes.this.type]

4. #### abstract def compilerSettings: ScalaSettings

5. #### abstract val coreBTypes: CoreBTypesProxyGlobalIndependent[BTypes.this.type]

6. #### abstract val inliner: Inliner[BTypes.this.type]

7. #### abstract def isCompilingPrimitive: Boolean

   True if the current compilation unit is of a primitive class (scala.Boolean et al).

   True if the current compilation unit is of a primitive class (scala.Boolean et al). Used only in assertions. Abstract here because its implementation depends on global.

8. #### abstract val localOpt: LocalOpt[BTypes.this.type]

9. #### abstract def recordPerRunCache[T <: Clearable](cache: T): T

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from BTypes to any2stringadd[BTypes] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (BTypes, B)

   Implicit information
     This member is added by an implicit conversion from BTypes to ArrowAssoc[BTypes] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object BOOL extends PrimitiveBType with Product with Serializable

7. #### object BYTE extends PrimitiveBType with Product with Serializable

8. #### object CHAR extends PrimitiveBType with Product with Serializable

9. #### object ClassBType extends Serializable

10. #### object DOUBLE extends PrimitiveBType with Product with Serializable

11. #### object FLOAT extends PrimitiveBType with Product with Serializable

12. #### object INT extends PrimitiveBType with Product with Serializable

13. #### object LONG extends PrimitiveBType with Product with Serializable

14. #### object SHORT extends PrimitiveBType with Product with Serializable

15. #### object UNIT extends PrimitiveBType with Product with Serializable

16. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

17. #### def bTypeForDescriptorOrInternalNameFromClassfile(desc: String): BType

    Obtain the BType for a type descriptor or internal name.

    Obtain the BType for a type descriptor or internal name. For class descriptors, the ClassBType is constructed by parsing the corresponding classfile.

    Some JVM operations use either a full descriptor or only an internal name. Example: ANEWARRAY java/lang/String // a new array of strings (internal name for the String class) ANEWARRAY [Ljava/lang/String; // a new array of array of string (full descriptor for the String class)

    This method supports both descriptors and internal names.

18. #### val callsitePositions: Map[MethodInsnNode, Position]

    Store the position of every MethodInsnNode during code generation.

    Store the position of every MethodInsnNode during code generation. This allows each callsite in the call graph to remember its source position, which is required for inliner warnings.

19. #### def classBTypeFromClassNode(classNode: ClassNode): ClassBType

    Construct the ClassBType for a parsed classfile.

20. #### val classBTypeFromInternalName: Map[InternalName, ClassBType]

    A map from internal names to ClassBTypes.

    A map from internal names to ClassBTypes. Every ClassBType is added to this map on its construction.

    This map is used when computing stack map frames. The asm.ClassWriter invokes the method `getCommonSuperClass`. In this method we need to obtain the ClassBType for a given internal name. The method assumes that every class type that appears in the bytecode exists in the map.

    Concurrent because stack map frames are computed when in the class writer, which might run on multiple classes concurrently.

21. #### def classBTypeFromParsedClassfile(internalName: InternalName): ClassBType

    Parse the classfile for `internalName` and construct the ClassBType.

    Parse the classfile for `internalName` and construct the ClassBType. If the classfile cannot be found in the `byteCodeRepository`, the `info` of the resulting ClassBType is undefined.

22. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

23. #### def ensuring(cond: (BTypes) ⇒ Boolean, msg: ⇒ Any): BTypes

    Implicit information
      This member is added by an implicit conversion from BTypes to Ensuring[BTypes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

24. #### def ensuring(cond: (BTypes) ⇒ Boolean): BTypes

    Implicit information
      This member is added by an implicit conversion from BTypes to Ensuring[BTypes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

25. #### def ensuring(cond: Boolean, msg: ⇒ Any): BTypes

    Implicit information
      This member is added by an implicit conversion from BTypes to Ensuring[BTypes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

26. #### def ensuring(cond: Boolean): BTypes

    Implicit information
      This member is added by an implicit conversion from BTypes to Ensuring[BTypes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

27. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

28. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

29. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

30. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from BTypes to StringFormat[BTypes] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

31. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

32. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

33. #### def inlineInfoFromClassfile(classNode: ClassNode): InlineInfo

    Build the InlineInfo for a class.

    Build the InlineInfo for a class. For Scala classes, the information is stored in the ScalaInlineInfo attribute. If the attribute is missing, the InlineInfo is built using the metadata available in the classfile (ACC_FINAL flags, etc).

34. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

35. #### val javaDefinedClasses: Set[InternalName]

    Contains the internal names of all classes that are defined in Java source files of the current compilation run (mixed compilation).

    Contains the internal names of all classes that are defined in Java source files of the current compilation run (mixed compilation). Used for more detailed error reporting.

36. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

37. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

38. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

39. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

40. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

41. #### val unreachableCodeEliminated: Set[MethodNode]

    Cache, contains methods whose unreachable instructions are eliminated.

    Cache, contains methods whose unreachable instructions are eliminated.

    The ASM Analyzer class does not compute any frame information for unreachable instructions. Transformations that use an analyzer (including inlining) therefore require unreachable code to be eliminated.

    This cache allows running dead code elimination whenever an analyzer is used. If the method is already optimized, DCE can return early.

42. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

43. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### def →[B](y: B): (BTypes, B)

    Implicit information
      This member is added by an implicit conversion from BTypes to ArrowAssoc[BTypes] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from BTypes to any2stringadd[BTypes]

### Inherited by implicit conversion StringFormat from BTypes to StringFormat[BTypes]

### Inherited by implicit conversion Ensuring from BTypes to Ensuring[BTypes]

### Inherited by implicit conversion ArrowAssoc from BTypes to ArrowAssoc[BTypes]

### Ungrouped